<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoValeCombustivel extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrbeneficiom          = $itens['NRBENEFICIOM']   ?? null;
        $dsobsbeneficiario     = $itens['DSOBSBENEFICIARIO']   ?? null;
        $cdtipovc              = $itens['CDTIPOVC']   ?? null;
        $cdtipoaltevc          = $itens['CDTIPOALTEVC']   ?? null;
        $nrpessoa              = $itens['NRPESSOA'] ?? null;
        $qtbeneficio           = $itens['QTBENEFICIO'] ?? null;
        $vrbeneficio           = $itens['VRBENEFICIO'] ?? null;
        $nreventom             = '100106659';
        $idvalordifebenef      = "VALOR";
        $idtpbeneficiario      = "T";
        $dtinscbeneficiario    = isset($itens['DTINSCBENEFICIARIO']) ? DateUtil::getDataDeString(substr($itens['DTINSCBENEFICIARIO'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtcancbeneficiario    = isset($itens['DTCANCBENEFICIARIO']) ? DateUtil::getDataDeString(substr($itens['DTCANCBENEFICIARIO'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : null;
        $nrorg                 = Utils::getParamters()->getNrorg();
        $nrvinculom            = $this->getSolicitacao()->getNrvinculom();
        $observacao            = $this->getObservacaoComProtocolo($dsobsbeneficiario);


        if($cdtipoaltevc === 'E') {
            ProcessamentoSolicitacaoUtil::cancelaBeneficiario($nrorg, $nrvinculom, $nrbeneficiom, $dtcancbeneficiario);
            return;
        }


        $beneficiario = ProcessamentoSolicitacaoUtil::retornaBeneficiario($nrorg, $nrvinculom, $nrbeneficiom);
        if(isset($beneficiario[0])) {
            throw new \Exception("Beneficiário já cadastrado.");
        }

        // Por Valor (Evento)
        if($cdtipovc === 'V') {
            $novobeneficiario = ProcessamentoSolicitacaoUtil::novoBeneficiario($nrorg, $nrvinculom, $nrpessoa, $nrbeneficiom, $qtbeneficio, $idtpbeneficiario, 
            $dtinscbeneficiario, $dtcancbeneficiario, $observacao, $nreventom, $vrbeneficio, $idvalordifebenef);
            return;
        }

        // Por KM
        $novobeneficiario = ProcessamentoSolicitacaoUtil::novoBeneficiario($nrorg, $nrvinculom, $nrpessoa, $nrbeneficiom, $qtbeneficio, $idtpbeneficiario, 
        $dtinscbeneficiario, $dtcancbeneficiario, $observacao, NULL, NULL);

    }
    
    public function rejeitar() {}

}
