<?php
namespace HCM\FPA\Services;
error_reporting(E_ERROR | E_PARSE);
use HCM\FPA\Repository\ItemLoteLancRepository;
use HCM\FPA\Repository\BloqueioEventoVinculoRepository;
use HCM\Util\Repositories;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\DateUtil;

class ItemLoteLancService {

    /**
     * @var ItemLoteLancRepository
     */
    protected $itemLoteLancRepository;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ItemLoteLancRepository $itemLoteLancRepository, BloqueioEventoVinculoRepository $bloqueioVinculoRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->itemLoteLancRepository = $itemLoteLancRepository;
        $this->itemLoteLanc = Repositories::FPA_ITEMLOTELANC;
        $this->bloqueioEventVincRepository = $bloqueioVinculoRepository;
    }

    /**
     * @return int
     */
    
    public function getNrCalculoFolha($dtmescompetec, $nrtipomoviment, $nrorg) {
        $result = $this->itemLoteLancRepository->getNrCalculoFolha($dtmescompetec, $nrtipomoviment, $nrorg);
        return $result;
    }

    public function updateIdStatusLoteLanc($idstatuslotelanc, $nrlotelancevento, $nrorg) {
        $this->itemLoteLancRepository->updateIdStatusLoteLanc($idstatuslotelanc, $nrlotelancevento, $nrorg);
    }

    public function cancelarLote($nrorg, $nrlotelancevento) {
        $this->itemLoteLancRepository->cancelarLote($nrorg, $nrlotelancevento);
    }

    public function getLiquido($nrvinculom, $nrcalculofolha, $nrorg) {
        return $this->itemLoteLancRepository->getLiquido($nrvinculom, $nrcalculofolha, $nrorg);
    }

    public function getIdeventodemonst($nrorgpadrao, $nreventom, $dtmescompetencia, $nrorg) {
        return $this->itemLoteLancRepository->getIdeventodemonst($nrorgpadrao, $nreventom, $dtmescompetencia, $nrorg);
    }
    
    public function updateIteLoteInline($row){
        try {
            
            $iteLote = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_ITEMLOTELANC)->findOneBy(array('nrorg' => $row['NRORG'],
            'nrvinculom' => $row['NRVINCULOM'], 'nritlotelanc' => $row['NRITLOTELANC'], 'nreventom' => $row['NREVENTOM']));
            
            $row['VREVENTOLOTE'] = str_replace(array('.'), '', $row['VREVENTOLOTE']);
            $row['VREVENTOLOTE'] = str_replace(array(','), '.', $row['VREVENTOLOTE']);
            $row['VREVENTOLOTE'] = (float)($row['VREVENTOLOTE']);
            
            $row['VRREFFOLHALOTE'] = str_replace(array('.'), '', $row['VRREFFOLHALOTE']);
            $row['VRREFFOLHALOTE'] = str_replace(array(','), '.', $row['VRREFFOLHALOTE']);
            $row['VRREFFOLHALOTE'] = (float)($row['VRREFFOLHALOTE']);
            
            $iteLote->setVreventolote($row['VREVENTOLOTE']);
            $iteLote->setVrreffolhalote($row['VRREFFOLHALOTE']);
            
            \Setforms2\Shared\Registry::getEntityManager()->persist($iteLote);
            \Setforms2\Shared\Registry::getEntityManager()->flush($iteLote);
            
        } catch (Exception $e) {
            throw $e;    
        }
    }
    
    public function deleteItensLoteChecked($rows) {
        
        try {
            $this->entityManager->beginTransaction();
            
            foreach($rows as $row){
                
                $iteLote = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_ITEMLOTELANC)->findOneBy(array('nrorg' => $row['NRORG'],
                'nrlotelancevento' => $row['NRLOTELANCEVENTO'], 'nritlotelanc' => $row['NRITLOTELANC']));  
                $this->entityManager->remove($iteLote);
            }
            
            $this->entityManager->flush();
            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function geraItemLote($dataSet){
        
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $nrorgPadrao = $this->hcmParameters->getNrorgPadrao();
        $vrLote = abs($dataSet['VREVENTOLOTE']);
        $vrRefLote = abs($dataSet['VRREFFOLHALOTE']);
        $nrLote = $dataSet['NRLOTELANCEVENTO'];
        
        //Vinculos
        $vinculos = $this->retornaVinculos($dataSet);
        
        foreach($vinculos as $vinculo){
            foreach ($dataSet['NREVENTO_LIST'] as $nrEventom) {
                $msg = array();
                $disponibilidade = true;
                $bloq = $this->verificaEventoBloqueado($nrorg, $nrEventom, $vinculo->getNrtipovinculom());
                if ($bloq !== null){
                    if ($bloq['NREVENTOMPARA'] === null) {
                        $this->msg[] = array('msg' => 'Operação bloqueada. O evento '.$nrEventom.' não pode ser lançado para o vínculo "'.$vinculo->getNrvinculom().' - '.$vinculo->getNmvinculom(). '"!');
                        $disponibilidade = false;
                    } else {
                        $msg[] = array('msg' => 'Operação bloqueada.  O evento '.$nrEventom.' não pode ser lançado para o vínculo "'.$vinculo->getNrvinculom().' - '.$vinculo->getNmvinculom().'" e foi ajustado para o evento '.$bloq['NREVENTOMPARA'].'!');
                        $disponibilidade = true;
                        $nrEventom = $bloq['NREVENTOMPARA'];
                    }
                } else {
                    $disponibilidade = true;
                }
                if ($disponibilidade === true) {
                    $itensLote = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_ITEMLOTELANC)->findBy(array('nrorg' => $this->hcmParameters->getNrorgTrabalho(),
                    'nrlotelancevento' => $nrLote, 'nreventom' => $nrEventom, 'nrvinculom' => $vinculo->getNrvinculom()));  
                    
                    if($itensLote){
                        continue;
                    }
                    
                    $iteLote = new $this->itemLoteLanc;
                    
                    $iteLote->setVreventolote($vrLote);
                    $iteLote->setVrreffolhalote($vrRefLote);
                    $iteLote->setNrvinculom($vinculo->getNrvinculom());
                    $iteLote->setNreventom($nrEventom);
                    $iteLote->setNrlotelancevento($nrLote);
                    $iteLote->setNrorg($nrorg);
                    $iteLote->setIdativo('S');
                    $iteLote->setDtinclusao(DateUtil::getDataAtual());
                    $iteLote->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                    $iteLote->setCdoperinclusao($this->hcmParameters->getCdoperador());
                    $iteLote->setDtultatu(DateUtil::getDataAtual());
                    $iteLote->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                    $iteLote->setCdoperultatu($this->hcmParameters->getCdoperador());
            
                    $iteLote->setNritlotelanc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_ITEMLOTELANC', 1, 12, true));
                    
                    \Setforms2\Shared\Registry::getEntityManager()->persist($iteLote);
                    \Setforms2\Shared\Registry::getEntityManager()->flush($iteLote);
                }
            }
        }
        if (count($msg) > 0) {
            return $msg;
        } else {
            return null;
        }
    }
    
    public function retornaVinculos($dataSet){
        
        $params = array();
        $nrOrg = $this->hcmParameters->getNrorgTrabalho();
        $mesCompetencia = $this->hcmParameters->getDtCompetencia();
        
        $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($mesCompetencia));
        $params['p_dtultdiames'] = $dtUltDiaMes;
        
        $condIntervalo = null;
        $condProcesso = '(vm.dtrescisaovinc IS NULL
                                    OR vm.dtrescisaovinc > :p_dtultdiames
                                  )
                                  AND ((vm.dtadmissaovinc <> vm.dtrescisaovinc) OR vm.dtrescisaovinc IS NULL)
                                  AND vm.dtadmissaovinc <=  :p_dtultdiames';
    
                                  
        if(count($dataSet['LIST_NRESTRUTLEGAL']) > 0){
            $params['p_nrestruturam'] = array_slice($dataSet["LIST_NRESTRUTLEGAL"], 0, 1000);
            $condIntervalo = " vh.nrestrutlegal in (:p_nrestruturam)";
        }
        
        if(count($dataSet['LIST_NRESTRUTGEREN']) > 0){
            $params['p_nrestruturaGeren'] = array_slice($dataSet["LIST_NRESTRUTGEREN"], 0, 1000);
            $condIntervalo .= $condIntervalo ? ' AND' : '';
            $condIntervalo .= " vh.nrestrutgeren in (:p_nrestruturaGeren)";
        }
        
        if(count($dataSet['LIST_NRESTRUTSIND']) > 0){
            $params['p_nrestruturaSind'] = array_slice($dataSet["LIST_NRESTRUTSIND"], 0, 1000);
            $condIntervalo .= $condIntervalo ? ' AND' : '';
            $condIntervalo .= " vh.nrestrutsind in (:p_nrestruturaSind)";
        }

        if(count($dataSet['LIST_NROCUPACAOM']) > 0){
            $params['p_nrocupacaom'] = array_slice($dataSet["LIST_NROCUPACAOM"], 0, 1000);
            $condIntervalo .= $condIntervalo ? ' AND' : '';
            $condIntervalo .= " om.nrocupacaom in (:p_nrocupacaom)";
        }

        if(count($dataSet['LIST_NRTIPOHIERARQORG']) > 0){
            $params['p_nrtipohierarqorg'] = array_slice($dataSet["LIST_NRTIPOHIERARQORG"], 0, 1000);
            $condIntervalo .= $condIntervalo ? ' AND' : '';
            $condIntervalo .= " h.nrtipohierarqorg in (:p_nrtipohierarqorg)";
        }

        if(count($dataSet['LIST_NRESTRUTSUPERIORM']) > 0){
            $params['p_nrestrutsuperiorm'] = array_slice($dataSet["LIST_NRESTRUTSUPERIORM"], 0, 1000);
            $condIntervalo .= $condIntervalo ? ' AND' : '';
            $condIntervalo .= " h.nrestruturamsup in (:p_nrestrutsuperiorm)";
        }
        
        if(count($dataSet['NRVINCULOM_LIST']) > 0){
            //limita o IN em 1000 valores / máximo permitido pelo oracle
            $params['p_nrvinculom'] = array_slice($dataSet["NRVINCULOM_LIST"], 0, 1000);
            $condIntervalo .= $condIntervalo ? ' AND' : '';
            $condIntervalo .= " vm.nrvinculom in (:p_nrvinculom)";
        }
        
        $vinculos = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->retornaVinculos($nrOrg, $mesCompetencia, $condProcesso, $condIntervalo, 'ORDER BY vm.nmvinculom, vh.nrestrutlegal, vh.nrestrutgeren', null, true, null, null, null, $params);
                
        return $vinculos;
    }
    
    
    public function verificaEventoBloqueado ($nrorg, $nrevento, $tipoVinculo) {
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        $nrorg_padrao = $this->hcmParameters->getNrorgPadrao();
        return $this->bloqueioEventVincRepository->retornaEventosBloqueados($nrorg, $nrorg_padrao, $dtmescompetenc, $nrevento, $tipoVinculo);
    }

} 