<?php
/**
 * User: ArturMarcos
 * Date: 25/08/18
 * Time: 11:31
 * To change this template use File | Settings | File Templates.
 */

namespace HCM\Geral\Logic\Apolo;

require_once __DIR__.'/bootstrapApolo.php';

ini_set("memory_limit","2048M");

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;
use HCM\Geral\Logic\Apolo;
use Zeedhi\Framework\Session\Session;

class IniciaConsultaEsocial {
    
    private $filaTransmissaoEsocial;
    
    public function __construct($hcmParameters, $eSocialService, $parametros) {
        $this->consultaEsocial =  new \HCM\Geral\Logic\Apolo\ConsultaEsocial($hcmParameters, $eSocialService);
        $this->consultaEsocial->startaConsulta($parametros);
    }
    
}

error_reporting(E_ERROR | E_PARSE);

$entityManager = \Setforms2\Shared\Registry::getEntityManager();
$esoParametros = $entityManager->getRepository(Repositories::ESO_PARAMETRO)->getEsoParametro();

//Separa registros da Eso parametro por organização.
foreach($esoParametros as $key => $esoParametro){
    $registrosParametrosPorOrg[$esoParametro['NRORG']][] = $esoParametro;
}

//Percorre Organizações
foreach ($registrosParametrosPorOrg as $nrorg => $parametros) {
    
    $eSocialService = null;
    $instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();
    
    //$hcmParameters = $instanceManager->getService('\HCM\Util\HCMParameters');
    
    $session = new Session();
    $session->set('NRORG', $nrorg);
    $parametersXml = simplexml_load_file(__DIR__.'/../../../../../config/parameters.xml');
    $ProjectVersion = (string)$parametersXml->parameters->parameter[2];
    $hcmParameters = new HCMParameters($session, FPA::getTempDirectory(), null, $ProjectVersion);
    FPA::setSession($hcmParameters->getSession());
    
    $nrtpestrutlegal = 1;
    $nrtpestrutgeren = 6;
    $paramOrg = $entityManager->getRepository(Repositories::GPE_PARAMORG)->findOneBy(array('nrorg' => $nrorg));
    
    if($paramOrg){
        $nrtpestrutlegal = $paramOrg->getNrtpestrutlegal();
        $nrtpestrutgeren = $paramOrg->getNrtpestrutgeren();
    }
    
    $paramsHCM = array(
        "cdoperador"        => 1,
        "CDOPERADOR"        => 1,
        "nmoperador"        => null,
        "nrestruttrab"      => null,
        "nrorgpadrao"       => 0,
        "nrorg"             => $nrorg,
        "nrorgtrab"         => $nrorg,
        "dtmescompetenc"    => DateUtil::setDay(DateUtil::getDataAtual(), 1)->format('d/m/Y'),
        "dtmescompetencdiacorrente" => DateUtil::setDay(DateUtil::getDataAtual(), 1)->format('d/m/Y'),
        "nrtipoestrutlegal" => $nrtpestrutlegal,
        "nrtipoestrutgeren" => $nrtpestrutgeren,
        "idambientesal"     => 'REAL',
        "nrocorrecal"       => 1,
        "nrtpmodalidcal"    => 1,
        "nrtpmodalidsal"    => 1,
        "dataatual"         => DateUtil::getDataAtual(),
        "dtultimodiames"    => DateUtil::getUltimoDiaDoMes(DateUtil::getDataAtual())->format('d/m/Y'),
        "dtultimodiacompetencia" => DateUtil::getUltimoDiaDoMes(DateUtil::getDataAtual())->format('d/m/Y'),
    );
    
    foreach ($paramsHCM as $key => $value) {
        $hcmParameters->set($key, $value);
    }
    
    $fpa = $instanceManager->getService('\HCM\Util\FPA');
    $eSocialFactory = $instanceManager->getService('\HCM\Geral\Factory\ESocialFactory');
    $eSocialRepository = $instanceManager->getService('\HCM\Geral\Repository\ESocialRepository');
    $eSocialItensCadTabRepository = $instanceManager->getService('\HCM\Geral\Repository\ESocialItensCadTabRepository');
    $eSocialItensNaoPerRepository = $instanceManager->getService('\HCM\Geral\Repository\ESocialItensNaoPerRepository');
    $eSocialItensPeriodRepository = $instanceManager->getService('\HCM\Geral\Repository\ESocialItensPeriodRepository');
    $zhFileUploader = $instanceManager->getService('zhFileUploader');
    $esoSimplificadoService = $instanceManager->getService('\HCM\Geral\Services\EsoSimplificadoService');
    
    $eSocialService = new \HCM\Geral\Services\ESocialService(
        $entityManager,
        $hcmParameters,
        $fpa,
        $eSocialFactory,
        $eSocialRepository,
        $eSocialItensCadTabRepository,
        $eSocialItensNaoPerRepository,
        $eSocialItensPeriodRepository,
        $zhFileUploader,
        $esoSimplificadoService
    );
    
    foreach ($paramsHCM as $key => $value) {
        $hcmParameters->set($key, $value);
    }
    
    // $consultaEsocial = $instanceManager->getService('\HCM\Geral\Logic\Apolo\ConsultaEsocial');
    $consulta = new IniciaConsultaEsocial($hcmParameters, $eSocialService, $parametros);
    // $transmissão = new IniciaConsultaEsocial($consultaEsocial);
}