<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Util\HCM;
use HCM\Util\HCMParameters;
use HCM\Util\DateUtil;
use HCM\Util\Util;

class ImportacaoPlanilhaVinculoRepository {

    protected $connection;
    protected $entityManager;
    protected $hcmParameters;
    protected $perfacessparc;

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->perfacessparc = Repositories::PERFACESSPARC;
    }

    /**
     * @return array
     */
    public function getMaxId() {
      $maxIdQuery = "SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(DECODE(REPLACE(TRANSLATE(CDOPERADOR, '0123456789', '##########'), '#', ''), NULL, CDOPERADOR, NULL)))+1), 12, '0') MAX_ID FROM OPERADOR";
      return $this->connection->fetchAll($maxIdQuery);
  }

    public function deleteImpPlanilhaVinculoPessoa($nrpessoa, $nrorg, $entityManager) {
        if($entityManager)
          $this->entityManager = $entityManager;

        $tables = ['GPE_PESSOAH', 'GPE_PESSOA'];
        
        $params = ["P_NRORG"    => $nrorg,
                   "P_NRPESSOA" => $nrpessoa];

        foreach($tables as $table) {
          $query = $this->entityManager->getConnection()->prepare("
              DELETE FROM $table
              WHERE NRORG    = :P_NRORG
                AND NRPESSOA = :P_NRPESSOA"
          );
          
          $query->execute($params);
        }
    }

    public function novoPerfacessparcAdmissao($data){
      $nrperfacessparc = \HCM\Util\NovoCodigo::geraCodigo($data['NRORG'], 'PERFACESSPARC', 1, 12, true);

      $perfacessparc = new $this->perfacessparc;
      $perfacessparc->setNrperfacessparc($nrperfacessparc);
      $perfacessparc->setNrperfilacesso($data['NRPERFILACESSO']);
      $perfacessparc->setNrparcnegocio($data['NRPARCNEGOCIO']);
      $perfacessparc->setDtvalperfilparc(null);
      $perfacessparc->setIdativo($data['IDATIVO']);
      $perfacessparc->setNrorg($data['NRORG']);
      $perfacessparc->setNrorginclusao($data['NRORG']);
      $perfacessparc->setNrorgultatu($data['NRORG']);
      $perfacessparc->setCdoperinclusao($data['CDOPERINCLUSAO']);
      $perfacessparc->setCdoperultatu($data['CDOPERULTATU']);
      $perfacessparc->setDtinclusao($data['DTINCLUSAO']);
      $perfacessparc->setDtultatu($data['DTULTATU']);

      $this->entityManager->persist($perfacessparc);
      $this->entityManager->flush($perfacessparc);

      unset($perfacessparc);
  }
}