<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Util\Util;
use HCM\Util\HCMParameters;
use HCM\Geral\Repository\DateTime;
use HCM\Util\DateUtil;

class ParametrizacaoEsocialRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function geraInsertParametrizacaoEsocial($nreventom)
    {   
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        $sql = $this->entityManager->getConnection()->prepare("
        SELECT DISTINCT  FPA_EVENTOM.NREVENTOM,
                                   CASE
                                     WHEN FPA_EVENTOM.NREVENTOM IN (1015) AND TM.NRTIPOMOVIMENT <> 10 THEN '3'
                                     WHEN FPA_EVENTOM.NREVENTOM IN (1290) AND TM.NRTIPOMOVIMENT = 1 THEN '4'
                                     WHEN FPA_EVENTOM.NREVENTOM IN (1310, 1510, 1520) AND TM.NRTIPOMOVIMENT = 1 THEN '2'
                                     WHEN FPA_EVENTOM.NREVENTOM NOT IN (331) AND FPA_EVENTOH.IDEVENTODEMONST = 'S' THEN '3'
                                     ELSE DECODE(FPA_EVENTOM.IDTIPOEVENTO,'PROVENTO','1','DESCONTO','2','ENCARGO','3','TOTAL','3')
                                   END NRTIPORUBRICA,
                                   NVL(CP.CDESOCIAL,'00') NRINCIDECP,
                                   DECODE( FPA_EVENTOM.NREVENTOM, 3080, '79', NVL(IRRF.CDESOCIAL,'79') ) NRINCIDEIRRF,
                                   NVL(FGTS.CDESOCIAL,'00') NRINCIDEFGTS,
                                   TM.NRTIPOMOVIMENT
                    FROM FPA_EVENTOM 
                    JOIN FPA_EVENTOH ON FPA_EVENTOH.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                    AND FPA_EVENTOH.NRORG = FPA_EVENTOM.NRORG
                                    AND FPA_EVENTOH.DTMESCOMPETENC = (SELECT MAX(EH.DTMESCOMPETENC)
                                                                        FROM FPA_EVENTOH EH
                                                                       WHERE EH.NREVENTOM = FPA_EVENTOH.NREVENTOM
                                                                         AND EH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    JOIN FPA_TIPOMOVIMENT TM ON TM.NRTIPOMOVIMENT IN (1,2,4,10,19,22)
                    JOIN NATUREZARUBRICA ON  NATUREZARUBRICA.NRNATURUBR = FPA_EVENTOH.NRNATURUBR
               /*CONTRIBUICAO PREVIDENCIARIA NOVO*/
                 LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
                              FROM FPA_INCIDEVENTO IE
                              JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                              JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                   AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                              FROM FPA_GRPITEM 
                                                             WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                          GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT ) CP ON CP.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                         AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
               /*IRRF NOVO*/
               LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
                            FROM FPA_INCIDEVENTO IE
                            JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                            JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                  AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                             FROM FPA_GRPITEM 
                                                            WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                        GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT) IRRF ON IRRF.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                        AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
               /*FGTS NOVO*/
               LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, INC.CDESOCIAL
                            FROM FPA_INCIDEVENTO IE
                            JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                            JOIN INCIDENCIAFGTS INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                             AND IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                             FROM FPA_GRPITEM 
                                                            WHERE NRGRPINCIDE = 48)) FGTS ON FGTS.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                                                 AND INSTR(','||FGTS.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
               /*CONTRIBUICAO SINDICAL NOVO*/
                 LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL
                              FROM FPA_INCIDEVENTO IE
                              JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                              JOIN INCIDENCIASIND INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                    AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                             FROM FPA_GRPITEM 
                                                            WHERE NRGRPINCIDE = 49) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                          GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT) SIND ON SIND.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                          AND INSTR(','||SIND.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
                WHERE FPA_EVENTOM.NREVENTOM = :P_NREVENTOM
                ORDER BY FPA_EVENTOM.NREVENTOM, TM.NRTIPOMOVIMENT");
        $sql->execute(
            array(
                "P_NREVENTOM"         => $nreventom,
                "P_DTMESCOMPETENC"   => $dtmescompetenc
                
            )
        );

        return $sql->fetchAll();
    }

    public function insereParametrizacaoEsocial($parametrizacaoEsocial)
    {
        try {         
            $esorubrica = Repositories::ESO_RUBRICA;
            
            $novo = new $esorubrica;
            $novo->setNreventom($parametrizacaoEsocial["NREVENTOM"]);
            $novo->setNrtipomoviment($parametrizacaoEsocial["NRTIPOMOVIMENT"]);
            $novo->setIdativo('S');
            $novo->setNrtiporubrica($parametrizacaoEsocial["NRTIPORUBRICA"]);
            $novo->setCdincidecp($parametrizacaoEsocial["NRINCIDECP"]);
            $novo->setCdincidefgts($parametrizacaoEsocial["NRINCIDEFGTS"]);
            $novo->setCdincideirrf($parametrizacaoEsocial["NRINCIDEIRRF"]);
            $novo->setNrorg($this->hcmParameters->getNrorgTrabalho());
            $novo->setDtinclusao(DateUtil::getDataAtual());
            $novo->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $novo->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $novo->setDtultatu(DateUtil::getDataAtual());
            $novo->setCdoperultatu($this->hcmParameters->getCdoperador());
            $novo->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $novo->setNrrubrica(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'ESO_RUBRICA', 1, 12, true));
            
            $this->entityManager->persist($novo);
            $this->entityManager->flush();
            return $novo;
        } catch(\Exception $e) {
            //throw $th;
        }
    }

    public function buscaEventoComNaturezaRubrica($nreventom)
    {
        try {
            $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
            $sql = $this->entityManager->getConnection()->prepare("
            SELECT  FPA_EVENTOM.NREVENTOM,
                    NATUREZARUBRICA.NRNATURUBR,
                    FPA_EVENTOH.NRORG
                        FROM FPA_EVENTOM 
                        JOIN FPA_EVENTOH ON FPA_EVENTOH.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                        AND FPA_EVENTOH.NRORG = FPA_EVENTOM.NRORG
                                        AND FPA_EVENTOH.DTMESCOMPETENC = (SELECT MAX(EH.DTMESCOMPETENC)
                                                                            FROM FPA_EVENTOH EH
                                                                           WHERE EH.NREVENTOM = FPA_EVENTOH.NREVENTOM
                                                                             AND EH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                        JOIN NATUREZARUBRICA ON  NATUREZARUBRICA.NRNATURUBR = FPA_EVENTOH.NRNATURUBR
                    WHERE FPA_EVENTOM.NREVENTOM = :P_NREVENTOM");
            $sql->execute(
                array(
                    "P_NREVENTOM"         => $nreventom,
                    "P_DTMESCOMPETENC"   => $dtmescompetenc
                    
                )
            );
    
            return $sql->fetchAll();
        } catch(\Exception $e) {
        }
    }

}
