<?php
namespace HCM\Geral\Services;

use HCM\Geral\Repository\PessoaRepository;
use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Geral\Entity\GpepessoaEntity;

use HCM\FPA\Services\ExportacaoExcelService;
use HCM\Util\FPA;
use Zeedhi\Framework\HTTP\Kernel;

class PessoaService {

    /**
     * @var pessoaRepository
     */
    protected $pessoaRepository;

    protected $pessoa;
    protected $pessoah;

    public function __construct(EntityManager $entityManager, PessoaRepository $pessoaRepository, HCMParameters $hcmParameters, ExportacaoExcelService $exportacaoExcelService, Kernel $httpKernel) {
        $this->entityManager = $entityManager;
        $this->pessoaRepository = $pessoaRepository;
        $this->hcmParameters = $hcmParameters;
        $this->gpePessoaEntity = new GpepessoaEntity($entityManager, $hcmParameters);
        $this->gpePessoa = Repositories::GPE_PESSOA;
        $this->gpePessoah = Repositories::GPE_PESSOAH;
        $this->exportacaoExcelService = $exportacaoExcelService;
        $this->httpKernel = $httpKernel;
        $this->ExportacaoExcelService = $exportacaoExcelService;
    }

    public function novo(
        $nrorg, $nrparcnegocio, $dtmescompetencia, $nmpessoa, $apelido, $nrCertidaoNascimento, $dtNascimento,
        $idSexo, $nrCondicaoFisica, $nrCPF, $nrCTPS, $nrSerieCTPS, $sgufCTPS, $dtCTPS, $nrPIS, $dtPIS,
        $nrInscricaoINSS, $nrInscricaoISS, $cdEstadoCivil, $nrCertidaoCasamento, $dtCasamento,
        $idIsentoTituloEleitor, $nrTituloEleitor, $nrSecaoEleitoral, $nrZonaEleitoral, $nrHabilitacao,
        $dtHabilitacao, $dtValidadeHabilitacao, $categoriaHabilitacao, $nrCategoriaMilitar,
        $nrCertificadoReservista, $dsCertificadoReservista, $dtCertificadoReservista,
        $cdExpedicaoCertificadoReservista, $nrRaca, $idGrupoSanguineo, $idFatorRH, $cdpais, $sgEstado,
        $cdMunicipio, $nrRg, $orgaoExpedidorRG, $sgExpedidorRG, $dsLocalExpedicaoRG, $dtExpedicaoRG,
        $nrNacionalidade, $nrGrauInstrucao, $pronometrat = null, $nranochegapais = null,
        $nrdocuestrang = null, $idpesnaturaliza = null, $dtnaturalizapes = null, $idposvistoperm = null,
        $dtpermavisto = null, $nrconselhoreg = null, $nrinscrconsreg = null, $dtexconsreg = null,
        $sgufconsreg = null, $cdtpbaixapag = null, $nrlivrocertnasc = null, $nrfolhacertnasc = null, $dscomplcertnasc = null,$nrregctpspes = null,
        $nrclassestrang = null, $dsexpdocestr = null, $dtchegadapais = null, $idcotapcd = null
    )
    {
        $pessoa = $this->novoMestre($nrorg, $nrparcnegocio);
        $pessoah = $this->novoHistorico(
            $nrorg, $pessoa->getNrpessoa(), $dtmescompetencia, $nmpessoa, $apelido, $nrCertidaoNascimento,
            $dtNascimento, $idSexo, $nrCondicaoFisica, $nrCPF, $nrCTPS, $nrSerieCTPS, $sgufCTPS, $dtCTPS, $nrPIS,
            $dtPIS, $nrInscricaoINSS, $nrInscricaoISS, $cdEstadoCivil, $nrCertidaoCasamento, $dtCasamento,
            $idIsentoTituloEleitor, $nrTituloEleitor, $nrSecaoEleitoral, $nrZonaEleitoral, $nrHabilitacao,
            $dtHabilitacao, $dtValidadeHabilitacao, $categoriaHabilitacao, $nrCategoriaMilitar, $nrCertificadoReservista,
            $dsCertificadoReservista, $dtCertificadoReservista, $cdExpedicaoCertificadoReservista, $nrRaca,
            $idGrupoSanguineo, $idFatorRH, $cdpais, $sgEstado, $cdMunicipio, $nrRg, $orgaoExpedidorRG, $sgExpedidorRG,
            $dsLocalExpedicaoRG, $dtExpedicaoRG, $nrNacionalidade, $nrGrauInstrucao, $pronometrat, $nranochegapais, $nrdocuestrang,
            $idpesnaturaliza, $dtnaturalizapes, $idposvistoperm, $dtpermavisto, $nrconselhoreg, $nrinscrconsreg, $dtexconsreg,
            $sgufconsreg, $cdtpbaixapag, $nrlivrocertnasc, $nrfolhacertnasc, $dscomplcertnasc,$nrregctpspes,
            $nrclassestrang, $dsexpdocestr, $dtchegadapais, $idcotapcd 
        );
        return array($pessoa, $pessoah);
    }

    public function novoMestre($nrorg, $nrparcnegocio) {
        $pessoa = new $this->gpePessoa;

        $pessoa->setNrorg($nrorg);
        $pessoa->setNrparcnegocio($nrparcnegocio);

        $pessoa->setDtinclusao(DateUtil::getDataAtual());
        $pessoa->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $pessoa->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $pessoa->setDtultatu(DateUtil::getDataAtual());
        $pessoa->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $pessoa->setCdoperultatu($this->hcmParameters->getCdoperador());

        $pessoa->setNrpessoa(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'GPE_PESSOA', 1, 12, true));

        $this->entityManager->persist($pessoa);
        $this->entityManager->flush($pessoa);
        return $pessoa;
    }

    public function novoHistorico(
        $nrorg, $nrpessoa, $dtmescompetencia, $nmpessoa, $apelido, $nrCertidaoNascimento, $dtNascimento, $idSexo,
        $nrCondicaoFisica, $nrCPF, $nrCTPS, $nrSerieCTPS, $sgufCTPS, $dtCTPS, $nrPIS, $dtPIS, $nrInscricaoINSS,
        $nrInscricaoISS, $cdEstadoCivil, $nrCertidaoCasamento, $dtCasamento, $idIsentoTituloEleitor, $nrTituloEleitor,
        $nrSecaoEleitoral, $nrZonaEleitoral, $nrHabilitacao, $dtHabilitacao, $dtValidadeHabilitacao,
        $categoriaHabilitacao, $nrCategoriaMilitar, $nrCertificadoReservista, $dsCertificadoReservista,
        $dtCertificadoReservista, $cdExpedicaoCertificadoReservista, $nrRaca, $idGrupoSanguineo, $idFatorRH, $cdpais,
        $sgEstado, $cdMunicipio, $nrRg, $orgaoExpedidorRG, $sgExpedidorRG, $dsLocalExpedicaoRG, $dtExpedicaoRG,
        $nrNacionalidade, $nrGrauInstrucao, $pronometrat = null,  $nranochegapais = null,
        $nrdocuestrang = null, $idpesnaturaliza = null, $dtnaturalizapes = null, $idposvistoperm = null,
        $dtpermavisto = null, $nrconselhoreg = null, $nrinscrconsreg = null, $dtexconsreg = null,
        $sgufconsreg = null, $cdtpbaixapag = null, $nrlivrocertnasc = null, $nrfolhacertnasc = null, $dscomplcertnasc = null,$nrregctpspes = null,
        $nrclassestrang = null, $dsexpdocestr = null, $dtchegadapais = null, $idcotapcd = null
    )
    {
        $pessoah = new $this->gpePessoah;

        //setDadosPrincipais
        list($primeiroNome, $meioNome, $ultimoNome) = self::decompoeNomePessoa($nmpessoa);

        $pessoah->setNrorg($nrorg);
        $pessoah->setNrpessoa($nrpessoa);
        $pessoah->setNmpessoa($nmpessoa);
        $pessoah->setDsprinomepess($primeiroNome);
        $pessoah->setDsnomemeiopess((strlen($meioNome)> 20) ? substr($meioNome, 0, 20) : $meioNome);
        $pessoah->setDsultnomepess($ultimoNome);
        $pessoah->setDsapelidopess($apelido);
        $pessoah->setDtmescompetenc($dtmescompetencia);
        $pessoah->setDtnascpessoa($dtNascimento);
        $pessoah->setNrcertnascpes($nrCertidaoNascimento);
        $pessoah->setNrlivrocertnasc($nrlivrocertnasc);
        $pessoah->setNrfolhacertnasc($nrfolhacertnasc);
        $pessoah->setDscomplcertnasc($dscomplcertnasc);

        //setRegistroIdentidade
        $pessoah->setNrcpfpessoa($nrCPF);
        $pessoah->setNrrgpessoa($nrRg);
        $pessoah->setCdexrgpessoa($orgaoExpedidorRG);
        $pessoah->setSgufrgpessoa($sgExpedidorRG);
        $pessoah->setDslocalexrgpes($dsLocalExpedicaoRG);
        $pessoah->setDtexrgpessoa($dtExpedicaoRG);

        //setLocal
        $pessoah->setNrnacionalid($nrNacionalidade);
        $pessoah->setCdpais($cdpais);
        $pessoah->setSgestado($sgEstado);
        $pessoah->setCdmunicipio($cdMunicipio);

        //setImigrante
        $pessoah->setNranochegapais($nranochegapais);
        $pessoah->setNrdocuestrang($nrdocuestrang);
        $pessoah->setIdpesnaturaliza($idpesnaturaliza);
        $pessoah->setDtnaturalizapes($dtnaturalizapes);
        $pessoah->setIdposvistoperm($idposvistoperm);
        $pessoah->setDtpermavisto($dtpermavisto);
        $pessoah->setNrclassestrang($nrclassestrang);
        $pessoah->setDsexpdocestr($dsexpdocestr);
        $pessoah->setDtchegadapais($dtchegadapais ? DateUtil::getDataDeString($dtchegadapais) : null);

        //setDadosCarteiraTrabalho
        $pessoah->setNrctpspessoa($nrCTPS);
        $pessoah->setNrseriectpspes($nrSerieCTPS);
        $pessoah->setSgufctpspes($sgufCTPS);
        $pessoah->setDtctpspessoa($dtCTPS);
        $pessoah->setNrregctpspes($nrregctpspes);

        //setDadosImpostos
        $pessoah->setNrpispaseppes($nrPIS);
        $pessoah->setDtinscpispasep($dtPIS);
        $pessoah->setNrinscinsspes($nrInscricaoINSS);
        $pessoah->setNrinscisspes($nrInscricaoISS);

        //setDadosCivis
        $pessoah->setCdestacivil($cdEstadoCivil);
        $pessoah->setNrcertcasapes($nrCertidaoCasamento);
        $pessoah->setDtcasapessoa($dtCasamento);

        //setDadosEleitorais
        $pessoah->setIdisentituelei($idIsentoTituloEleitor);
        $pessoah->setNrtitueleipes($nrTituloEleitor);
        $pessoah->setNrsecaeleipes($nrSecaoEleitoral);
        $pessoah->setNrzonaeleipes($nrZonaEleitoral);

        //setDadosHabilitacaoVeiculo
        $pessoah->setNrcarthabpes($nrHabilitacao);
        $pessoah->setDthabcartpes($dtHabilitacao);
        $pessoah->setDtvalhabcartpes($dtValidadeHabilitacao);
        $pessoah->setDscateghabcart($categoriaHabilitacao);

        //setDadosMilitares
        $pessoah->setNrcatmilitarpe($nrCategoriaMilitar);
        $pessoah->setNrcertresepes($nrCertificadoReservista);
        $pessoah->setDscategcertrese($dsCertificadoReservista);
        $pessoah->setDtcertresepes($dtCertificadoReservista);
        $pessoah->setCdexcertresepes($cdExpedicaoCertificadoReservista);

        //setDadosFisicos
        $pessoah->setIdsexopessoa($idSexo);
        $pessoah->setNrracapessoa($nrRaca);
        $pessoah->setNrcondfispes($nrCondicaoFisica);
        $pessoah->setIdgrupsangupes($idGrupoSanguineo);
        $pessoah->setIdcotapcd($idcotapcd);
        $pessoah->setIdfatorrhpes($idFatorRH);

        //setDadosAdicionais
        $pessoah->setNrgrauinstr($nrGrauInstrucao);
        $pessoah->setNrconselhoreg($nrconselhoreg);
        $pessoah->setNrinscrconsreg($nrinscrconsreg);
        $pessoah->setDtexconsreg($dtexconsreg);
        $pessoah->setSgufconsreg($sgufconsreg);
        $pessoah->setCdtpbaixapag($cdtpbaixapag);

        if($pronometrat) {
            $pessoah->setDspronometrat($pronometrat);
        }else{
            $pronomeTratamento = $this->getPronomeTratamento($cdEstadoCivil, $idSexo);
            $pessoah->setDspronometrat($pronomeTratamento);
        }

        $pessoah->setDtinclusao(DateUtil::getDataAtual());
        $pessoah->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $pessoah->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $pessoah->setDtultatu(DateUtil::getDataAtual());
        $pessoah->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $pessoah->setCdoperultatu($this->hcmParameters->getCdoperador());

        $pessoah->setNrpessoah(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'GPE_PESSOAH', 1, 12, true));
        
        $this->entityManager->persist($pessoah);
        $this->entityManager->flush($pessoah);
        return $pessoah;
    }

    public function getPronomeTratamento($cdEstadoCivil,$idSexoPessoa) {
        if ($idSexoPessoa == 'M'){
            $pronomeTratamento = 'Sr.';
            return $pronomeTratamento;
        }
        else if ($idSexoPessoa == 'F' && $cdEstadoCivil == 'C'){
            $pronomeTratamento = 'Sra.';
            return $pronomeTratamento;
        }
        else {
            $pronomeTratamento = 'Srta.';
            return $pronomeTratamento;
        }
    }
    
    public function getPessoaRelacionamentos($parameters, $conditions) {
        return $this->pessoaRepository->getPessoaRelacionamentos($parameters, $conditions);
    }
    
    public function getTipoRelacionamentoPorPessoa($nrvinculom, $nrpessoa, $nrorg, $dtcompetencia){
        return $this->pessoaRepository->getTipoRelacionamentoPorPessoa($nrvinculom, $nrpessoa, $nrorg, $dtcompetencia);
    }
    
    public function decompoeNomePessoa($nmpessoa)
    {
        $arrayNmpessoa = explode(' ', $nmpessoa);
        $nomeMeio      = '';

        $primeiroNome = $arrayNmpessoa[0];
        for ($i = 1; $i < count($arrayNmpessoa) - 1; $i++) {
            $nomeMeio .= ' ' . $arrayNmpessoa[$i];
            $nomeMeio = trim($nomeMeio);
        }
        $ultimoNome = $arrayNmpessoa[count($arrayNmpessoa) - 1];
        $nomeMeio   = ($nomeMeio) ? : $ultimoNome;
        return array($primeiroNome, $nomeMeio, $ultimoNome);
    }
    
    public function validaCpfExistePessoa($row, $validaPessoa){
        $cpf = $row['NRCPFPESSOA'];
        $nrorg = $row['NRORG'];
        $row['NRPESSOA'] = array_key_exists('NRPESSOA', $row) ? $row['NRPESSOA'] : null; 
        $pis = array_key_exists('NRPISPASEPPES', $row) ? $row['NRPISPASEPPES'] : null;
        $ctps = !empty($row['NRCTPSPESSOA']) ? $row['NRCTPSPESSOA'] : null;
        $serie = !empty($row['NRSERIECTPSPES']) ? $row['NRSERIECTPSPES'] : null;
        $sgctps = !empty($row['SGUFCTPSPES']) ? $row['SGUFCTPSPES'] : null;
        $rg = !empty($row['NRRGPESSOA']) ? $row['NRRGPESSOA'] : null;
        $pessoaCpf = null;
        $pessoaPis = null;
        $pessoaCtps = null;
        $pessoaRg = null;
        $message = '';
        
        $order = array(".", "-");
        $replace = '';
        $formatedCpf = str_replace($order, $replace, $cpf);
        $formatedPis = str_replace($order, $replace, $pis);
        $formatedRg = str_replace($order, $replace, $rg);
        
        if($cpf){
            $pessoaCpf = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array("nrcpfpessoa" => $formatedCpf, "nrorg" => $nrorg));
        }
        if($pis){
            $pessoaPis = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array("nrpispaseppes" => $formatedPis,"nrorg" => $nrorg));    
        }
        
        if(!empty($ctps) && !empty($serie) && !empty($sgctps)){
            $pessoaCtps = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array('sgufctpspes' => $sgctps,'nrseriectpspes' => $serie,"nrctpspessoa" => $ctps,"nrorg" => $nrorg));    
        } else if(!empty($ctps) && !empty($serie) && empty($sgctps)){
            $pessoaCtps = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array('nrseriectpspes' => $serie,"nrctpspessoa" => $ctps,"nrorg" => $nrorg));    
        } else if(!empty($ctps) && !empty($sgctps) && empty($serie)){
            $pessoaCtps = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array('sgufctpspes' => $sgctps,"nrctpspessoa" => $ctps,"nrorg" => $nrorg));    
        } else if(!empty($ctps)) {
            $pessoaCtps = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array("nrctpspessoa" => $ctps,"nrorg" => $nrorg)); 
        }
        
        if(!empty($rg)){
            $pessoaRg = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array("nrrgpessoa" => $formatedRg,"nrorg" => $nrorg));
            if(empty($pessoaRg)){
                $pessoaRg = $this->entityManager->getRepository(Repositories::GPE_PESSOAH)->findOneBy(array("nrrgpessoa" => $rg,"nrorg" => $nrorg));
            }
        }
        
        if($pessoaCpf) {
            $nrpessoaCpf = $pessoaCpf->getNrpessoa();
            if(($nrpessoaCpf != $row['NRPESSOA'] || !$row['NRPESSOA']) && $validaPessoa){
                throw new \Exception(Messages::HCM00000_GER_PESSOA_CPF_ERROR.$pessoaCpf->getNmpessoa(), 10);
            }else if (($nrpessoaCpf != $row['NRPESSOA'] || !$row['NRPESSOA']) && !$validaPessoa){
                $message .= '- CPF já cadastrado para a pessoa: '.$pessoaCpf->getNmpessoa().' (Provável outro registro para mesmo CPF).<br>';
            }
        }
        if($pessoaPis) {
            $nrpessoaPis= $pessoaPis->getNrpessoa();
            if(($nrpessoaPis != $row['NRPESSOA'] || !$row['NRPESSOA']) && $validaPessoa){
                throw new \Exception(Messages::HCM00000_GER_PESSOA_PIS_ERROR.$pessoaPis->getNmpessoa(), 10);
            }else if (($nrpessoaPis != $row['NRPESSOA'] || !$row['NRPESSOA']) && !$validaPessoa){
                $message .= '- PIS já cadastrado para a pessoa: '.$pessoaPis->getNmpessoa().'(Provável outro registro para mesmo PIS).<br>';
            }    
        }
        if(!empty($pessoaCtps)) {
            $nrpessoaCtps= $pessoaCtps->getNrpessoa();
            if(($nrpessoaCtps != $row['NRPESSOA'] || !$row['NRPESSOA']) && $validaPessoa){
                throw new \Exception(Messages::HCM00000_GER_PESSOA_PIS_ERROR.$pessoaCtps->getNmpessoa(), 10);
            }else if (($nrpessoaCtps != $row['NRPESSOA'] || !$row['NRPESSOA']) && !$validaPessoa){
                $message .= '- CTPS já cadastrado para a pessoa: '.$pessoaCtps->getNmpessoa().'(Provável outro registro para mesmo CTPS).<br>';
            }    
        }
        if(!empty($pessoaRg)) {
            $nrpessoaRg= $pessoaRg->getNrpessoa();
            if(($nrpessoaRg != $row['NRPESSOA'] || !$row['NRPESSOA']) && $validaPessoa){
                throw new \Exception(Messages::HCM00000_GER_PESSOA_PIS_ERROR.$pessoaRg->getNmpessoa(), 10);
            }else if (($nrpessoaRg != $row['NRPESSOA'] || !$row['NRPESSOA']) && !$validaPessoa){
                $message .= '- RG já cadastrado para a pessoa: '.$pessoaRg->getNmpessoa().'(Provável outro registro para mesmo RG).<br>';
            }    
        }
        return $message; 
    }
    
    public function validaPessoaVinculo($row, $validaCPF = true){
        $nrorg = $row['NRORG'];
        $nrpessoa = $row['NRPESSOA'];
        if($validaCPF){
            $message = $this->validaCpfExistePessoa($row, false);
        }else{
            $message = '';
        }
        
        // todos os vínculos que a pessoa possui
        $vinculos = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->findBy(array("nrpessoa" => $nrpessoa,"nrorg" => $nrorg));
        
        $dtmescompetenc = date_create_from_format('d/m/Y', $this->hcmParameters->getDtCompetencia())->setTime(0,0);
        $ultdiacompetenc = date_create_from_format('d/m/Y', $this->hcmParameters->getUltimoDiaMes())->setTime(0,0);
        
        $dtmescompetenc = $dtmescompetenc->getTimestamp();
        $ultdiacompetenc = $ultdiacompetenc->getTimestamp();
        
        foreach($vinculos as $vinculo){
            
            $dtadmissaovinc = $vinculo->getDtadmissaovinc()->getTimestamp();
            $dtrescisaovinc = !empty($vinculo->getDtrescisaovinc()) ? $vinculo->getDtrescisaovinc()->getTimestamp() : null;
            
            // valida se o vínculo é ativo
            if($dtadmissaovinc <= $ultdiacompetenc && ($dtrescisaovinc > $ultdiacompetenc || $dtrescisaovinc == null)){
                
                if(!$row['NRCPFPESSOA']){
                    throw new \Exception(Messages::HCM00000_GER_PESSOA_VINCULO_ERROR, 10);
                }
                $tipovinculo = $vinculo->getNrtipovinculom();
                if($tipovinculo === 1){
                    $validaPessoa = $this->validaVinculoCLT($row);
                    if($validaPessoa){
                        throw new \Exception(Messages::HCM00000_GER_PESSOA_VINCULOCLT_ERROR.$validaPessoa,10);
                    }
                }    
            }
            $vinculo->setNmvinculom($row['NMPESSOA']);
            $this->entityManager->persist($vinculo);
            $this->entityManager->flush();
        }
        return $message;
    }
    
    public function validaVinculoCLT($row){
        $validaPessoa = '';
        if(!$row['NRPISPASEPPES']){
            $validaPessoa .= " PIS/PASEP,";
        }
        if(!$row['NRCTPSPESSOA']){
            $validaPessoa .= " Nº CTPS,";
        }
        if(!$row['NRSERIECTPSPES']){
            $validaPessoa .= " Nº série CTPS,";
        }
        // Validação retirada a pedido de cliente para não ser obrigatório a inserção de data CTPS.
        // if(!$row['DTCTPSPESSOA']){
        //     $validaPessoa .= " data CTPS,";
        // }
        //
        //if(!$row['SGUFCTPSPES']){
        //    $validaPessoa .= " UF CTPS,";
        //}
        
        // retorna a mensagem sem a última vírgula
        return !empty($validaPessoa) ? substr($validaPessoa, 0, -1) : null;
    }
    
    public function getRelacionadosPorVinculo($mesCompetencia, $vinculom, $nrorg, $filtro){
        return $this->pessoaRepository->getRelacionadosPorVinculo($mesCompetencia, $vinculom, $nrorg, $filtro);
        
    }
    public function setDataNascimentoPessoa($row){
        try{
            $nrParcNegocioRelac = $row['NRPARCNEGRELAC'];
            
            $pessoa = $this->gpePessoaEntity->retornaPessoaPorParceiro($nrParcNegocioRelac);
            
            $parceiro = $this->entityManager->getRepository(Repositories::PARCNEGOCIO)->findOneBy(
                array('nrparcnegocio' => $nrParcNegocioRelac, 'nrorg' => $row['NRORG'])
            );
            
            if($pessoa && $pessoa->historico && $parceiro /*&& $parceiro->getDtnascifundparc()*/){
                $dtNascAtual = DateUtil::getDataDeString($pessoa->historico->getDtnascpessoa());
                $dtNascAtualParc = DateUtil::getDataDeString($parceiro->getDtnascifundparc());
                
                if($row["DTNASCIFUNDPARC"] && ($row["DTNASCIFUNDPARC"] != $dtNascAtual || $row["DTNASCIFUNDPARC"] != $dtNascAtualParc)){
                    
                    if(!$dtNascAtualParc || $dtNascAtualParc != $row["DTNASCIFUNDPARC"]){
                        $this->entityManager->beginTransaction();
                        $parceiro->setDtnascifundparc(DateUtil::truncateData(DateUtil::getDataDeString($row["DTNASCIFUNDPARC"])));
                        $this->entityManager->persist($parceiro);
                        $this->entityManager->flush($parceiro);
                        $this->entityManager->commit();
                    }
                    
                    if(!$dtNascAtual || $dtNascAtual != $row["DTNASCIFUNDPARC"]){
                        $this->entityManager->beginTransaction();
                        $pessoa->historico->setDtnascpessoa(DateUtil::truncateData(DateUtil::getDataDeString($row["DTNASCIFUNDPARC"])));
                        $this->entityManager->persist($pessoa->historico);
                        $this->entityManager->flush($pessoa->historico);
                        $this->entityManager->commit();
                    }   
                }else{
                    if(!$dtNascAtualParc || $dtNascAtual->format('dd/mm/YYYY') != $dtNascAtualParc->format('dd/mm/YYYY')){
                        $this->entityManager->beginTransaction();
                        $parceiro->setDtnascifundparc($dtNascAtual);
                        $this->entityManager->persist($parceiro);
                        $this->entityManager->flush($parceiro);
                        $this->entityManager->commit();
                    }
                    
                    if(!$dtNascAtual || $dtNascAtual->format('dd/mm/YYYY') != $dtNascAtual->format('dd/mm/YYYY')){
                        $this->entityManager->beginTransaction();
                        $pessoa->historico->setDtnascpessoa($dtNascAtual);
                        $this->entityManager->persist($pessoa->historico);
                        $this->entityManager->flush($pessoa->historico);
                        $this->entityManager->commit();
                    }   
                }
            }
        } catch (Exception $e) {
            $this->entityManager->rollback();
            throw new Exception($e->getMessage());
        }   
    }
    
    public function verificaHistoricoCompetenciaPessoa($nrorg, $nrpessoa, $competencia = null) {
        
        $competencia = $competencia == null? $this->hcmParameters->getDtCompetencia() : $competencia;
        $gpepessoa = $this->pessoaRepository->retornaHistoricoAtualPorPessoa($nrorg, $nrpessoa, $competencia);
        
        $dthistorico = DateUtil::getDataDeString($gpepessoa->getDtmescompetenc(), DateUtil::FORMATO_BRASILEIRO_DATAHORA);
        $dtcompetenc = DateUtil::getDataDeString($competencia);
        $dtcompetenc->setTime(0,0,0);

        if (DateUtil::comparaDatas($dthistorico, $dtcompetenc)) {
            $this->novoHistorico($nrorg, $gpepessoa->getNrpessoa(), $dtcompetenc, $gpepessoa->getNmpessoa(), $gpepessoa->getDsapelidopess(), $gpepessoa->getNrcertnascpes(), 
                $gpepessoa->getDtnascpessoa(), $gpepessoa->getIdsexopessoa(), $gpepessoa->getNrcondfispes(), $gpepessoa->getNrcpfpessoa(), $gpepessoa->getNrctpspessoa(), 
                $gpepessoa->getNrseriectpspes(), $gpepessoa->getSgufctpspes(), $gpepessoa->getDtctpspessoa(), $gpepessoa->getNrpispaseppes(), $gpepessoa->getDtinscpispasep(), 
                $gpepessoa->getNrinscinsspes(), $gpepessoa->getNrinscisspes(), $gpepessoa->getCdestacivil(), $gpepessoa->getNrcertcasapes(), $gpepessoa->getDtcasapessoa(), 
                $gpepessoa->getIdisentituelei(), $gpepessoa->getNrtitueleipes(), $gpepessoa->getNrsecaeleipes(), $gpepessoa->getNrzonaeleipes(), $gpepessoa->getNrcarthabpes(),
                $gpepessoa->getDthabcartpes(), $gpepessoa->getDtvalhabcartpes(), $gpepessoa->getDscateghabcart(), $gpepessoa->getNrcatmilitarpe(), $gpepessoa->getNrcertresepes(), 
                $gpepessoa->getDscategcertrese(), $gpepessoa->getDtcertresepes(), $gpepessoa->getCdexcertresepes(), $gpepessoa->getNrracapessoa(), $gpepessoa->getIdgrupsangupes(), 
                $gpepessoa->getIdfatorrhpes(), $gpepessoa->getCdpais(), $gpepessoa->getSgestado(), $gpepessoa->getCdmunicipio(), $gpepessoa->getNrrgpessoa(), $gpepessoa->getCdexrgpessoa(), 
                $gpepessoa->getSgufrgpessoa(), $gpepessoa->getDslocalexrgpes(), $gpepessoa->getDtexrgpessoa(), $gpepessoa->getNrnacionalid(), $gpepessoa->getNrgrauinstr(), 
                $gpepessoa->getDspronometrat(), $gpepessoa->getNranochegapais(), $gpepessoa->getNrdocuestrang(), $gpepessoa->getIdpesnaturaliza(), $gpepessoa->getDtnaturalizapes(), 
                $gpepessoa->getIdposvistoperm(), $gpepessoa->getDtpermavisto(), $gpepessoa->getNrconselhoreg(), $gpepessoa->getNrinscrconsreg(), $gpepessoa->getDtexconsreg(), 
                $gpepessoa->getSgufconsreg(), $gpepessoa->getCdtpbaixapag(), $gpepessoa->getNrlivrocertnasc(), $gpepessoa->getNrfolhacertnasc(), $gpepessoa->getDscomplcertnasc(), 
                $gpepessoa->getNrregctpspes(), $gpepessoa->getNrclassestrang(), $gpepessoa->getDsexpdocestr(), $gpepessoa->getDtchegadapais());
            
        }
    }
    
    public function atualizaHistoricoPessoa($nrorg, $nrpessoa) {
        try {
            $this->entityManager->beginTransaction();
            
            $gpepessoa = $this->pessoaRepository->retornaHistoricoAtualPorPessoa($nrorg, $nrpessoa, $this->hcmParameters->getDtCompetencia());

            $gpepessoa->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $gpepessoa->setCdoperultatu($this->hcmParameters->getCdoperador());
            $gpepessoa->setDtultatu(DateUtil::getDataAtual());

            $this->entityManager->persist($gpepessoa);
            $this->entityManager->flush();
            $this->entityManager->commit();
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function baixarPlanilhaContaCorrente($nrorg, $nmarquivo) {
        $cabecalho = array(
            "Nr. vinculo",
            "Matrícula",
            "Matrícula eSocial",
            "Nome",
            "Cod Banco",
            "Cod Agencia",
            "Conta Corrente",
            "Tipo Conta"
        );
        $dadosExemplo[0] = array(
            "353",
            "",
            "",
            "Nome do Vinculo",
            "",
            "",
            "",
            ""
        );
        
        return $this->exportacaoExcelService->gravarTemplate_1($nrorg, $cabecalho, $nmarquivo, $dadosExemplo);
    }
    
    public function validaMunicipio($row) {
        $temMunicipio = $this->entityManager->getRepository(Repositories::MUNICIPIO)->findOneBy([
            'cdpais'      => $row['CDPAIS'],
            'sgestado'    => $row['SGESTADO'],
            'cdmunicipio' => $row['CDMUNICIPIO'],
            'nrorg'       => [$row['NRORG'], $this->hcmParameters->getNrorgPadrao()]
        ]);
        
        if(!is_object($temMunicipio)) {
            $munic = Repositories::MUNICIPIO; 
            $municipio = new $munic;
            
            $municipio->setCdpais($row['CDPAIS']);
            $municipio->setSgestado($row['SGESTADO']);
            $municipio->setCdmunicipio($row['CDMUNICIPIO']);
            $municipio->setNmmunicipio($row['NMMUNICIPIO']);
            $municipio->setNrorg($this->hcmParameters->getNrorgPadrao());
            
    
            $municipio->setDtinclusao(DateUtil::getDataAtual());
            $municipio->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $municipio->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $municipio->setDtultatu(DateUtil::getDataAtual());
            $municipio->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $municipio->setCdoperultatu($this->hcmParameters->getCdoperador());
    
            $this->entityManager->persist($municipio);
            $this->entityManager->flush($municipio);
        }
    }

    public function verificarContaCorrente($nrParcNegocio, $nrOrg) {
        return $this->pessoaRepository->verificarContaCorrente($nrParcNegocio, $nrOrg);
    }
} 