<?php
require "service/autoloader.php";
require __DIR__."/../vendor/autoload.php";
require __DIR__."/../vendor/zeedhi/framework/bootstrap.php";
require 'service/userDataLoader.php';

// Load test files
include('tests/Util.php');
include('tests/IntegrationTests/HcmServicesIntegrationTestCase.php');

// Load specified services and parameters
$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();
$instanceManager->loadFromFile(__DIR__ . '/../config/base.xml');
$instanceManager->loadFromFile(__DIR__ . '/db.xml');
$instanceManager->loadFromFile(__DIR__ . '/environment.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/parameters.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/report.xml');
$instanceManager->loadFromFile(__DIR__ . '/../services.xml');
$instanceManager->compile();

use Doctrine\DBAL\Types\Type;
Type::overrideType(Type::DATE, 'Setforms2\Shared\ORM\DateTimeType');
Type::overrideType(Type::DATETIME, 'Setforms2\Shared\ORM\DateTimeType');

$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());
